%define aurox_ver 9.4
%define rel 0.20031122.3

%define builddoc 1

Name: fpc
Version: 1.0.11
Release: %{aurox_ver}.aur.%{rel}
ExclusiveArch: i386 i586 i686
Copyright: GPL
Group: Development/Languages
Source: %{name}-%{version}-src.tar.gz
Source1: %{name}-%{version}.cfg
Patch0: fpc-1.0.11-heaptrc.patch
Patch1: fpc-1.0.11-systypes.patch
Patch2: fpc-1.0.11-docs.patch
Summary: Free Pascal Compiler
URL: http://www.freepascal.org/
BuildRoot: %{_tmppath}/fpc-build
BuildRequires: fpc

%define fpcdir %{_libdir}/fpc/%{version}
%define docdir %{_docdir}/fpc-%{version}
%define exampledir %{docdir}/examples
%define fpcsrcdir %{_datadir}/fpcsrc

%define builddocdir %{buildroot}%{docdir}
%define buildmandir %{buildroot}%{_datadir}
%define buildbindir %{buildroot}%{_bindir}
%define buildlibdir %{buildroot}%{_libdir}
%define buildexampledir %{buildroot}%{exampledir}


%description
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible 32bit
Pascal Compiler. It comes with fully TP 7.0 compatible run-time library.
Some extensions are added to the language, like function overloading. Shared
libraries can be linked. Basic Delphi support is already implemented (classes,
exceptions,ansistrings,RTTI). This package contains commandline compiler and
utils. Provided units are the runtime library (RTL), free component library
(FCL), gtk,ncurses,zlib, mysql,postgres,ibase bindings.

###############################################################################
# fpc.rpm
#

%prep
%setup -q -c
%patch0 -p1 -b .heaptrc
%patch1 -p1 -b .systypes
%patch2 -p1 -b .docs

%build
mkdir -p baksrc
cp -a compiler fcl packages rtl utils ./baksrc/

NEWPP=`pwd`/compiler/ppc386
NEWFPDOC=`pwd`/utils/fpdoc/fpdoc
	make compiler_cycle
	make rtl_clean rtl_smart FPC=${NEWPP}
	make packages_base_smart FPC=${NEWPP}
	make fcl_smart FPC=${NEWPP}
	make packages_extra_smart FPC=${NEWPP}
	make utils_all FPC=${NEWPP}
%if %{builddoc}
	make -C docs pdf FPDOC=${NEWFPDOC}
%endif

%install
if [ %{buildroot} != "/" ]; then
	rm -rf %{buildroot}
fi

NEWPP=`pwd`/compiler/ppc386
INSTALLOPTS="FPC=${NEWPP} INSTALL_PREFIX=%{buildroot}/usr INSTALL_LIBDIR=%{buildlibdir} \
		INSTALL_DOCDIR=%{builddocdir} INSTALL_BINDIR=%{buildbindir}"
make compiler_distinstall ${INSTALLOPTS}
make rtl_distinstall ${INSTALLOPTS}
make packages_distinstall ${INSTALLOPTS}
make fcl_distinstall ${INSTALLOPTS}
make utils_distinstall ${INSTALLOPTS}

make demo_install ${INSTALLOPTS} INSTALL_SOURCEDIR=%{buildexampledir}
make doc_install ${INSTALLOPTS}
make man_install ${INSTALLOPTS} INSTALL_PREFIX=%{buildmandir}
	
%if %{builddoc}
make -C docs pdfinstall DOCINSTALLDIR=%{builddocdir}
%endif

# create link
ln -sf %{fpcdir}/ppc386 %{buildroot}%{_bindir}/ppc386

# fix examples dir
mv -f %{buildroot}/usr/doc/%{name}-%{version}/examples %{buildroot}%{_docdir}/%{name}-%{version}/examples/misc

# sample config
mkdir -p %{buildroot}%{_sysconfdir}
cp -a %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}.cfg

# copy source to destination dir
mkdir -p %{buildroot}%{fpcsrcdir}
cp -a ./baksrc/* %{buildroot}%{fpcsrcdir}/
# the palmos libcrt.a archive is making trouble
rm -f %{buildroot}%{fpcsrcdir}/rtl/palmos/libcrt.a

%clean
make compiler_clean
make rtl_clean
make packages_clean
make fcl_clean
make utils_clean

%if %{builddoc}
make -C docs clean
%endif

if [ %{buildroot} != "/" ]; then
	rm -rf %{buildroot}
fi

%files
%defattr(-, root, root)
%{_bindir}/*
%{fpcdir}
%doc %{docdir}/NEWS
%doc %{docdir}/README
%doc %{docdir}/faq*
%{_mandir}/man?/*.?.gz
%{_libdir}/%{name}/lexyacc
%config(noreplace) %{_sysconfdir}/%{name}.cfg

###############################################################################
# fpc-docs.rpm
#

%package docs
Group: Development/Languages
Summary: Free Pascal Compiler - Documentation
%description docs
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible 32bit
Pascal Compiler. It comes with fully TP 7.0 compatible run-time library.
Some extensions are added to the language, like function overloading. Shared
libraries can be linked. Basic Delphi support is already implemented (classes,
exceptions,ansistrings,RTTI). This package contains commandline compiler and
utils. Provided units are the runtime library (RTL), free component library
(FCL), gtk,ncurses,zlib, mysql,postgres,ibase bindings.

This package contains the documentation in PDF format.

%if %{builddoc}
%files docs
%defattr(-, root, root)
%doc %{docdir}/*.pdf
%endif

%package examples
Group: Development/Languages
Summary: Free Pascal Compiler - Examples
%description examples
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible 32bit
Pascal Compiler. It comes with fully TP 7.0 compatible run-time library.
Some extensions are added to the language, like function overloading. Shared
libraries can be linked. Basic Delphi support is already implemented (classes,
exceptions,ansistrings,RTTI). This package contains commandline compiler and
utils. Provided units are the runtime library (RTL), free component library
(FCL), gtk,ncurses,zlib, mysql,postgres,ibase bindings.

This package contains examples of Free Pascal programs.

%files examples
%defattr(-, root, root)
%dir %{docdir}/examples
%{docdir}/examples/*

%package source
Group: Development/Languages
Summary: Free Pascal Compiler - Source
%description source
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible 32bit
Pascal Compiler. It comes with fully TP 7.0 compatible run-time library.
Some extensions are added to the language, like function overloading. Shared
libraries can be linked. Basic Delphi support is already implemented (classes,
exceptions,ansistrings,RTTI). This package contains commandline compiler and
utils. Provided units are the runtime library (RTL), free component library
(FCL), gtk,ncurses,zlib, mysql,postgres,ibase bindings.

This package contains source of Free Pascal compiler and units. These sources are
required to build Lazarus graphical IDE.

%files source
%defattr(-, root, root)
%dir %{fpcsrcdir}
%{fpcsrcdir}/*

%changelog
* Tue May 11 2004 Aurox Team <aurox@aurox.org> 0:1.0.11-9.4.aur.0.20031122.3
- rebuild fixing manpage dirs

